Moscow is hosting a major international conference, which is attended by n scientists from different countries. Each of the scientists knows exactly one language. For convenience, we enumerate all languages of the world with integers from 1 to 109.

In the evening after the conference, all n scientists decided to go to the cinema. There are m movies in the cinema they came to. Each of the movies is characterized by two distinct numbers — the index of audio language and the index of subtitles language. The scientist, who came to the movie, will be very pleased if he knows the audio language of the movie, will be almost satisfied if he knows the language of subtitles and will be not satisfied if he does not know neither one nor the other (note that the audio language and the subtitles language for each movie are always different).

Scientists decided to go together to the same movie. You have to help them choose the movie, such that the number of very pleased scientists is maximum possible. If there are several such movies, select among them one that will maximize the number of almost satisfied scientists.

Input

The first line of the input contains a positive integer n (1 ≤ n ≤ 200 000) — the number of scientists.

The second line contains n positive integers a1, a2, ..., an (1 ≤ ai ≤ 109), where ai is the index of a language, which the i-th scientist knows.

The third line contains a positive integer m (1 ≤ m ≤ 200 000) — the number of movies in the cinema.

The fourth line contains m positive integers b1, b2, ..., bm (1 ≤ bj ≤ 109), where bj is the index of the audio language of the j-th movie.

The fifth line contains m positive integers c1, c2, ..., cm (1 ≤ cj ≤ 109), where cj is the index of subtitles language of the j-th movie.

It is guaranteed that audio languages and subtitles language are different for each movie, that is bj ≠ cj.

Output

Print the single integer — the index of a movie to which scientists should go. After viewing this movie the number of very pleased scientists should be maximum possible. If in the cinema there are several such movies, you need to choose among them one, after viewing which there will be the maximum possible number of almost satisfied scientists.

If there are several possible answers print any of them.

Examples

Input
3
2 3 2
2
3 2
2 3
Output
2
Input
6
6 3 1 1 3 7
5
1 2 3 4 5
2 3 4 5 1
Output
1

Note

In the first sample, scientists must go to the movie with the index 2, as in such case the 1-th and the 3-rd scientists will be very pleased and the 2-nd scientist will be almost satisfied.

In the second test case scientists can go either to the movie with the index 1 or the index 3. After viewing any of these movies exactly two scientists will be very pleased and all the others will be not satisfied.

题意:有n个科学家,每个人都会一种语言,用整数a【i】表示,m部电影,每个电影用b【i】语言配音,用c【i】语言填字幕,

求一个电影,他被最多的人听懂,如果有多种方案,求此情况下,被最多人看懂的(a【i】 == c【i】就可以看懂)。

思路: 我们可以想到,把科学家会的语言计数,然后对电影先按b【i】数量后按c【i】数量排序。

计数的话,我们肯定要离散化,因为 0 <= i <= 2e5

1、我们可以用map,但是注意这题是卡了unordered_map的,直接用map或者hash_map都行

 include<bits/stdc++.h>
using namespace std; int n,m;
const int maxn = 2e5+;
int sc[maxn]; map<int,int>mp;
struct Mo
{
int b;
int c;
int id;
} mov[maxn]; bool cmp(Mo a,Mo b)
{
if(a.b == b.b)
return a.c > b.c;
return a.b > b.b;
}
int main()
{
scanf("%d",&n);
int tmp;
int cnt = ;
for(int i=; i<=n; i++)
{
scanf("%d",&tmp);
if(!mp[tmp])
{
mp[tmp] = ++cnt;
sc[cnt]++;
}
else
sc[mp[tmp]]++;
}
scanf("%d",&m);
for(int i=; i<=m; i++)
scanf("%d",&tmp),mov[i].id = i,mov[i].b = sc[mp[tmp]];
for(int i=; i<=m; i++)
scanf("%d",&tmp),mov[i].c = sc[mp[tmp]];
sort(mov+,mov++m,cmp);
printf("%d\n",mov[].id);
}

2、我们可以用二分离散,就是先排序a【i】,然后用unique或者手写去重,用二分查找a【i】在去重后的哪个位置,得出离散后的结果

这样我们在求取b【i】数量(或c【i】)的时候,也是二分查找b【i】(或c【i】)在去重后的位置,但是的出来位置上的电影编号不一定等于b【i】(或c【i】),

如果相等那么b【i】 = sc【pos】 (sc是之前科学家语言的计数),如果不等,b【i】 = 0(说明科学家中没人懂这语言);

 #include<cstdio>
#include<iostream>
#include<algorithm>
using namespace std; int n,m;
const int maxn = 2e5+;
int a[maxn];
int b[maxn];
int sc[maxn]; struct Mo
{
int b;
int c;
int id;
} mov[maxn]; bool cmp(Mo a,Mo b)
{
if(a.b == b.b)
return a.c > b.c;
return a.b > b.b;
}
int query(int x,int len)
{
return lower_bound(b+,b++len,x)-b;
}
int main()
{
scanf("%d",&n);
for(int i=; i<=n; i++)scanf("%d",&a[i]);
sort(a+,a++n);
int tmp;
int len = ;
for(int i=;i<=n;i++)
{
if(i== || a[i] != a[i-])
b[++len] = a[i];
} for(int i=;i<=n;i++)
{
tmp = query(a[i],len);
sc[tmp]++;
}
scanf("%d",&m);
for(int i=; i<=m; i++)
{
scanf("%d",&tmp),mov[i].id = i;
int pos = query(tmp,len);
if(b[pos] == tmp)mov[i].b = sc[pos];
else mov[i].b = ;
}
for(int i=; i<=m; i++)
{
scanf("%d",&tmp);
int pos = query(tmp,len);
if(b[pos] == tmp)mov[i].c = sc[pos];
else mov[i].c = ;
}
sort(mov+,mov++m,cmp);
printf("%d\n",mov[].id);
}

最新文章

  1. BitTorrent DHT 协议中文翻译
  2. 仿造slither.io第二步:加个地图,加点吃的
  3. JAVA中toString方法的作用
  4. LTE切换与TAU问题
  5. C/C++ 关于生成静态库(lib)/动态库(dll)文件如何使用(基于windows基础篇)
  6. (任寒韬)WebApp群主 - MobileTech 资料
  7. 2015 CCPC-C-The Battle of Chibi (UESTC 1217)(动态规划+树状数组)
  8. 【Java基础】“数三退一”问题的代码实现
  9. HDU - 5234 Happy birthday
  10. js 选项卡
  11. 均值滤波去除图像噪声的matlab程序
  12. 管理Mac的Python环境
  13. LeetCode之“链表”:Add Two Numbers
  14. net core 接入 Google Authenticator
  15. Core Location实现定位
  16. .NET第一章
  17. 图书管理系统(无中间件,用装饰器的)-----未基于FORM组件
  18. 【C++ 模板迭代器实例/半素数】
  19. TransactionScop事务机制的使用
  20. iOS常用小功能

热门文章

  1. JdbcUtil
  2. Confluence 6 重构查找索引
  3. LoadRunner监控window系统各项指标详解
  4. verilog-testbench 时钟和复位模板
  5. vue 之webpack打包工具的使用
  6. 浅谈FastJson的TypeReference用法
  7. hdu4009最小树形图板子题
  8. 基于concurrent.futures的进程池 和线程池
  9. Python变量的作用域
  10. Java 获取窗口的宽、高